<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: C:/Data/Git/MeLOn/common/inc/exceptions.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('exceptions_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">exceptions.h</div></div>
</div><!--header-->
<div class="contents">
<a href="exceptions_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**********************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Copyright (c) 2020 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * This program and the accompanying materials are made available under the</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> *</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *  @file exceptions.h</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment"> *</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment"> *  @brief File declaring the MeLOn exception class.</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment"> *</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment"> **********************************************************************************/</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;exception&gt;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;sstream&gt;</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &lt;typeinfo&gt;</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="foldopen" id="foldopen00032" data-start="{" data-end="};">
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="class_melon_exception.html">   32</a></span><span class="keyword">class </span><a class="code hl_class" href="class_melon_exception.html">MelonException</a> : <span class="keyword">public</span> std::exception {</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span><span class="keyword">private</span>:</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="class_melon_exception.html#a073260a73dcd9a890469a0d16ac0a932">   34</a></span>    std::string <a class="code hl_variable" href="class_melon_exception.html#a073260a73dcd9a890469a0d16ac0a932">_msg</a>{ <span class="stringliteral">&quot;&quot;</span> };         ;</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="class_melon_exception.html#a859054fbc757ff1e8832e6644a9417b0">   35</a></span>    <a class="code hl_function" href="class_melon_exception.html#a859054fbc757ff1e8832e6644a9417b0">MelonException</a>();</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span><span class="keyword">public</span>:</div>
<div class="foldopen" id="foldopen00042" data-start="{" data-end="}">
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno"><a class="line" href="class_melon_exception.html#a452e9b8d9402120d65da21cc0963248b">   42</a></span>    <span class="keyword">explicit</span> <a class="code hl_function" href="class_melon_exception.html#a452e9b8d9402120d65da21cc0963248b">MelonException</a>(<span class="keyword">const</span> std::string&amp; arg) :</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>        <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(arg, nullptr)</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>    {</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    }</div>
</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span> </div>
<div class="foldopen" id="foldopen00053" data-start="{" data-end="}">
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno"><a class="line" href="class_melon_exception.html#ac41ac06f98a2bbd10226000b2aa6417b">   53</a></span>    <a class="code hl_function" href="class_melon_exception.html#ac41ac06f98a2bbd10226000b2aa6417b">MelonException</a>(<span class="keyword">const</span> std::string&amp; arg, <span class="keyword">const</span> std::exception&amp; e) :</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(arg, &amp;e)</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>    {</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>    }</div>
</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span> </div>
<div class="foldopen" id="foldopen00064" data-start="{" data-end="}">
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno"><a class="line" href="class_melon_exception.html#a68266a43eb716b795f749cd33f66e936">   64</a></span>    <a class="code hl_function" href="class_melon_exception.html#a68266a43eb716b795f749cd33f66e936">MelonException</a>(<span class="keyword">const</span> std::string&amp; arg, <span class="keyword">const</span> std::exception* e)</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>    {</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        std::ostringstream message;</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        <span class="keywordflow">if</span> (e) {</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>            <span class="keywordflow">if</span> (<span class="keyword">typeid</span>(*e).name() != <span class="keyword">typeid</span>(*this).name()) {</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>                message &lt;&lt; <span class="stringliteral">&quot;  Original std::exception: &quot;</span> &lt;&lt; <span class="keyword">typeid</span>(*e).name() &lt;&lt; <span class="stringliteral">&quot;: &quot;</span> &lt;&lt; std::endl</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>                    &lt;&lt; <span class="stringliteral">&quot;   &quot;</span>;</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>            }</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>            message &lt;&lt; e-&gt;what() &lt;&lt; std::endl;</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        }</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>        message &lt;&lt; arg;</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        <a class="code hl_variable" href="class_melon_exception.html#a073260a73dcd9a890469a0d16ac0a932">_msg</a> = message.str();</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>    }</div>
</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span> </div>
<div class="foldopen" id="foldopen00083" data-start="{" data-end="}">
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno"><a class="line" href="class_melon_exception.html#acfc925bc3c90a8c2eb64ec832c161631">   83</a></span>    <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code hl_function" href="class_melon_exception.html#acfc925bc3c90a8c2eb64ec832c161631">what</a>() const noexcept</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>    {</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="class_melon_exception.html#a073260a73dcd9a890469a0d16ac0a932">_msg</a>.c_str();</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>    }</div>
</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span> </div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>};</div>
</div>
<div class="ttc" id="aclass_melon_exception_html"><div class="ttname"><a href="class_melon_exception.html">MelonException</a></div><div class="ttdoc">This class defines the exceptions thrown by FeedForwardNet.</div><div class="ttdef"><b>Definition</b> exceptions.h:32</div></div>
<div class="ttc" id="aclass_melon_exception_html_a073260a73dcd9a890469a0d16ac0a932"><div class="ttname"><a href="class_melon_exception.html#a073260a73dcd9a890469a0d16ac0a932">MelonException::_msg</a></div><div class="ttdeci">std::string _msg</div><div class="ttdef"><b>Definition</b> exceptions.h:34</div></div>
<div class="ttc" id="aclass_melon_exception_html_a452e9b8d9402120d65da21cc0963248b"><div class="ttname"><a href="class_melon_exception.html#a452e9b8d9402120d65da21cc0963248b">MelonException::MelonException</a></div><div class="ttdeci">MelonException(const std::string &amp;arg)</div><div class="ttdoc">Constructor used for forwarding.</div><div class="ttdef"><b>Definition</b> exceptions.h:42</div></div>
<div class="ttc" id="aclass_melon_exception_html_a68266a43eb716b795f749cd33f66e936"><div class="ttname"><a href="class_melon_exception.html#a68266a43eb716b795f749cd33f66e936">MelonException::MelonException</a></div><div class="ttdeci">MelonException(const std::string &amp;arg, const std::exception *e)</div><div class="ttdoc">Constructor used printing a FeedForwardNet Exception.</div><div class="ttdef"><b>Definition</b> exceptions.h:64</div></div>
<div class="ttc" id="aclass_melon_exception_html_a859054fbc757ff1e8832e6644a9417b0"><div class="ttname"><a href="class_melon_exception.html#a859054fbc757ff1e8832e6644a9417b0">MelonException::MelonException</a></div><div class="ttdeci">MelonException()</div></div>
<div class="ttc" id="aclass_melon_exception_html_ac41ac06f98a2bbd10226000b2aa6417b"><div class="ttname"><a href="class_melon_exception.html#ac41ac06f98a2bbd10226000b2aa6417b">MelonException::MelonException</a></div><div class="ttdeci">MelonException(const std::string &amp;arg, const std::exception &amp;e)</div><div class="ttdoc">Constructor used for forwarding.</div><div class="ttdef"><b>Definition</b> exceptions.h:53</div></div>
<div class="ttc" id="aclass_melon_exception_html_acfc925bc3c90a8c2eb64ec832c161631"><div class="ttname"><a href="class_melon_exception.html#acfc925bc3c90a8c2eb64ec832c161631">MelonException::what</a></div><div class="ttdeci">const char * what() const noexcept</div><div class="ttdoc">Function to return the error message.</div><div class="ttdef"><b>Definition</b> exceptions.h:83</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_bdd9a5d540de89e9fe90efdfc6973a4f.html">common</a></li><li class="navelem"><a class="el" href="dir_a065f42410ce59d310ee6ca453a28844.html">inc</a></li><li class="navelem"><a class="el" href="exceptions_8h.html">exceptions.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
